{--------------------------------------------------------}
{                                                        }
{    Jogo aterrisagem lunar                              }
{                                                        }
{    Mdulo de mensagens                                 }
{                                                        }
{    Autor: Diego Costa Pontes                           }
{                                                        }
{    Em agosto/2006                                      }
{                                                        }
{--------------------------------------------------------}

unit lumsg;

interface
uses dvWin, dvCrt;

const
    msgTitulo = 'Aterrisagem Lunar';

function pegaTextoMensagem (nomeArq: string): string;
procedure mensagem (nomeArq: string; nlf: integer);
function confirma (nomeArq: string): char;

implementation

{--------------------------------------------------------}
{              descobre o texto da mensagem              }
{--------------------------------------------------------}

function pegaTextoMensagem (nomeArq: string): string;
var s : string;
const CRLF = ^M^J;
begin
    s := '';

    if nomeArq = 'LUINIC' then
        s := 'Alunisagem - um desafio para pilotos!'
    else
    if nomeArq = 'LUQLITRO' then
        s := 'Quantos litros? '
    else
    if nomeArq = 'LUBENVIN' then
        s := 'Benvindo ao jogo de Alunisagem!'
    else
    if nomeArq = 'LUDESINS' then
        s := 'Deseja instrues? '
    else
    if nomeArq = 'LUINSTRT' then
        s := CRLF + CRLF + 'INSTRUES DO JOGO.' + CRLF + CRLF +
             'O objetivo do jogo  aterrisar um foguete na superfcie da Lua, ' + CRLF +
             'no menor tempo e gastando o mnimo de combustvel.' + CRLF + CRLF +
             'O foguete tem inicialmente velocidade zero e ser puxado para baixo' + CRLF +
             'pela fora da gravidade lunar. Voc usar os foguetes propulsores' + CRLF +
             'para desacelerar esta queda, informando para isso, a quantidade' + CRLF +
             'desejada de combustvel a aplicar usando as teclas numricas de zero'  + CRLF +
             'a nove. Pressionando ENTER voc ser informado de sua altura.' + CRLF +
             'Pressionando a barra de espao voc obter todas as suas informaes,' + CRLF +
             'como tempo, altura, velocidade e combustvel restante.' + CRLF +
             'Voc ser informado regularmente da sua altitude.' + CRLF + CRLF +
             'Tente pousar com suavidade, caso contrrio o foguete explode.'
    else
    if nomeArq = 'LUDIFICU' then
        s := 'Digite a sua opo de dificuldade de 1 a 3: '
    else
    if nomeArq = 'LUERRARQ' then
        s := 'Erro no arquivo de configurao!'
    else
    if nomeArq = 'LUNAOENT' then
        s := 'No entendi, digite de novo.'
    else
    if nomeArq = 'LUCOMSUF' then
        s := 'No h combustvel suficiente!'
    else
    if nomeArq = 'LUNVEXPL' then
        s := 'A nave explodiu!'
    else
    if nomeArq = 'LUNVPOUS' then
        s := 'Muito bem, a nave pousou!'
    else
    if nomeArq = 'LUVELINI' then
        s := 'A velocidade  de '
    else
    if nomeArq = 'LUSEMCOM' then
        s := 'Nave sem combustvel!'
    else
    if nomeArq = 'LUCOMJOG' then
        s := 'Comear jogo? '
    else
    if nomeArq = 'LUJOGDEN' then
        s := 'Quer jogar de novo? '
    else
    if nomeArq = 'LUCONHEC' then
        s := 'Quer conhecer os ases pilotos? '
    else
    if nomeArq = 'LUPNTMAX' then
        s := 'Use as setas para conhecer os ases pilotos e sua pontuao'
    else
    if nomeArq = 'LUPARABE' then
        s := 'Parabns, voc entrar para o quadro de ases pilotos!!!'
    else
    if nomeArq = 'LULENOME' then
        s := 'Digite seu nome:'
    else
    if nomeArq = 'LUALTINI' then
        s := 'A altura inicial  de '
    else
    if nomeArq = 'LUCOMINI' then
        s := 'Combustvel atual: '
    else
    if nomeArq = 'LUCOMGAS' then
        s := 'Combustivel gasto: '
    else
    if nomeArq = 'LUCOMMAX' then
        s := 'Combustvel mximo a colocar por rodada: '
    else
    if nomeArq = 'LUVELFIM' then
        s := 'Velocidade final: '
    else
    if nomeArq = 'LUPTSFIM' then
        s := 'Sua pontuao: '
    else
    if nomeArq = 'LUCOMBTQ' then
        s := 'Combustvel: '
    else
    if nomeArq = 'LUTEMPO' then
        s := 'Tempo: '
    else
    if nomeArq = 'LUALTURA' then
        s := 'Altura: '
    else
    if nomeArq = 'LUVELOC' then
        s := 'Velocidade: '
    else
    if nomeArq = 'LUVCSOBE' then
        s := 'Voc est subindo!'
    else
    if nomeArq = 'LUAPENTR' then
        s := 'Pressione enter para comear a alunisagem.'
    else
    if nomeArq = 'LUCOMVAZ' then
        s := 'COMBUSTVEL VAZADO! '
    else
    if nomeArq = 'LUENTOPE' then
        s := 'Entupimento na mangueira, combustvel utilizado: '
    else
    if nomeArq = 'LUOLA' then
        s := 'Ol, voc est a bordo do COLUMBIAVOX 1 e ter de conduzir' + CRLF +
             'a nave em segurana at a aterrizagem na Lua. BOA SORTE!'
    else
    if nomeArq = 'LUGOSTEI' then
        s := 'Gostei de jogar com voc!'
    else
    if nomeArq = 'LUTCHAU' then
        s := 'Tchau...'
    else
    if nomeArq = 'LUJOFISI' then
        s := 'Escolha: I - jogo pela intuio  F - jogo pela fsica: '
    else
    if nomeArq = 'LULENTO' then
        s := 'ATENO, voc est muito lento, deixe a nave cair.'
    else
    if nomeArq = 'LURAPIDO' then
        s := 'ATENO, voc est muito rpido prximo ao solo.'
    else
    if nomeArq = 'LUDEMAIS' then
        s := 'ATENO, voc est rpido demais.'
    else
    if nomeArq = 'LUFIMCOM' then
        s := 'Fim do combustvel.'
    else
    if nomeArq = 'LUNSUPOR' then
        s := 'A nave no suportou a velocidade e explodiu! Voc virou p espacial.'
    else
    if nomeArq = 'LUFORORB' then
        s := 'A nave saiu da rbita lunar.' +  CRLF +
             'Voc no conseguir voltar, est irremediavelmente perdido no espao.'
    else
    if nomeArq = 'LUENTERR' then
        s := 'Voc usou muito combustvel prximo ' +
             'ao cho, criando uma cratera e ' +
             'enterrando a nave no solo. Voc perdeu.'
    else
    if nomeArq = 'LUINJETE' then
        s := 'Injete mais combustvel.'

    else
        s := '--> Mensagem invlida: ' + nomeArq;

   pegaTextoMensagem := s;
end;

{--------------------------------------------------------}
{                    d uma mensagem                     }
{--------------------------------------------------------}

procedure mensagem (nomeArq: string; nlf: integer);
var i: integer;
    s: string;

begin
    s := pegaTextoMensagem (nomeArq);

    if nlf >= 0 then write (s);
    for i := 1 to nlf do
         writeln;

    if existeArqSom (nomearq) then
        sintSom (nomearq)
    else
        sintetiza (s);
end;

{---------------------------------------------------------}

function confirma (nomeArq: string): char;
var c, c2: char;
begin
    limpaBufTec;
    mensagem (nomeArq, 0);
    sintLeTecla (c, c2);
    writeln;
    confirma := upcase (c);
end;

end.
